/* subset of tbl/vcc_types.h which we support */

/* standard text for defaults doc */
#define DEFDOC The default fallback is

#define DEF_ACL
#define DEFDOC_ACL
VCC_TYPE(ACL, acl)

#define DEF_BACKEND = NULL
#define DEFDOC_BACKEND DEFDOC no backend.
VCC_TYPE(BACKEND, backend)

#define DEF_BLOB
#define DEFDOC_BLOB
VCC_TYPE(BLOB, blob)

#define DEF_BODY
#define DEFDOC_BODY
VCC_TYPE(BODY, body)

#define DEF_BOOL
#define DEFDOC_BOOL
VCC_TYPE(BOOL, bool)

#define DEF_BYTES
#define DEFDOC_BYTES
VCC_TYPE(BYTES, bytes)

#define DEF_DURATION = 0
#define DEFDOC_DURATION DEFDOC 0s.
VCC_TYPE(DURATION, duration)

// VCC_TYPE(ENUM, enum)

#define DEF_HEADER
#define DEFDOC_HEADER
VCC_TYPE(HEADER, header)

// VCC_TYPE(HTTP, http)
// VCC_TYPE(INSTANCE, instance)

#define DEF_INT = 0
#define DEFDOC_INT DEFDOC 0.
VCC_TYPE(INT, int)

#define DEF_IP
#define DEFDOC_IP
VCC_TYPE(IP, ip)

#define DEF_PROBE
#define DEFDOC_PROBE
VCC_TYPE(PROBE, probe)

#define DEF_REAL = 0.0
#define DEFDOC_REAL DEFDOC 0.0.
VCC_TYPE(REAL, real)

#define DEF_STEVEDORE
#define DEFDOC_STEVEDORE
VCC_TYPE(STEVEDORE, stevedore)

// VCC_TYPE(STRANDS)

#define DEF_STRING = 0
#define DEFDOC_STRING DEFDOC the empty string.
VCC_TYPE(STRING, string)
#ifdef VCCTPL
$Method VOID .foreach(STRING string, SUB sub, STRING delim=",")

Breaks ``string`` into a sequence of zero or more nonempty tokens,
seperated by ``delim``, and successively calls ``sub`` with the object
set to each token.

Processing ends for a nonempty ``return()`` from ``sub``.
#endif

// VCC_TYPE(STRINGS)
// VCC_TYPE(STRING_LIST)
// VCC_TYPE(SUB)

#define DEF_TIME = 0
#define DEFDOC_TIME DEFDOC the epoch (1970/1/1 0:00:00 GMT).
VCC_TYPE(TIME, time)

// VCC_TYPE(VCL)
// VCC_TYPE(VOID)
#undef VCC_TYPE
